#ifndef _ENDIAN_H
#define _ENDIAN_H

#if 1

long get_long(void *addr);
void set_long(void *addr, long value);
short get_word(void *addr);
void set_word(void *addr, short value);

#define GET_LONG get_long
#define SET_LONG set_long
#define GET_WORD get_word
#define SET_WORD set_word

#else

#define SET_LONG(addr, value) (((unsigned char *) (addr))[0] = \
			          (unsigned char) ((value)>>24), \
			       ((unsigned char *) (addr))[1] = \
			          (unsigned char) ((value)>>16), \
			       ((unsigned char *) (addr))[2] = \
				  (unsigned char) ((value)>>8), \
			       ((unsigned char *) (addr))[3] = \
				  (unsigned char) (value)) 

			       
#define SET_WORD(addr, value) (((unsigned char *) (addr))[0] = \
			          (unsigned char) ((value)>>8), \
			       ((unsigned char *) (addr))[1] = \
			          (unsigned char) (value)) 

#define GET_LONG(addr) (( ((unsigned char *) (addr))[0] << 24 ) | \
			( ((unsigned char *) (addr))[1] << 16 ) | \
			( ((unsigned char *) (addr))[2] << 8 ) | \
			( ((unsigned char *) (addr))[3] ))

#define GET_WORD(addr) (( ((unsigned char *) (addr))[0] << 8 ) | \
			( ((unsigned char *) (addr))[1] ))

#endif
#endif

